
_Send_I2C:

;LCD_I2C_hard_06.mbas,24 :: 		sub procedure Send_I2C (dim dat as byte)      ' Test I2C for LCD
;LCD_I2C_hard_06.mbas,26 :: 		I2C1_Start
	CALL        _I2C1_Start+0, 0
;LCD_I2C_hard_06.mbas,27 :: 		I2C1_Wr(Waddr)      ' send address via I2C (device address + W)
	MOVLW       78
	MOVWF       FARG_I2C1_Wr_data_+0 
	CALL        _I2C1_Wr+0, 0
;LCD_I2C_hard_06.mbas,28 :: 		I2C1_Wr(dat)
	MOVF        FARG_Send_I2C_dat+0, 0 
	MOVWF       FARG_I2C1_Wr_data_+0 
	CALL        _I2C1_Wr+0, 0
;LCD_I2C_hard_06.mbas,29 :: 		I2C1_stop
	CALL        _I2C1_Stop+0, 0
;LCD_I2C_hard_06.mbas,30 :: 		end sub
L_end_Send_I2C:
	RETURN      0
; end of _Send_I2C

_Read_I2C:

;LCD_I2C_hard_06.mbas,32 :: 		sub function Read_I2C as byte
;LCD_I2C_hard_06.mbas,33 :: 		I2C1_Start
	CALL        _I2C1_Start+0, 0
;LCD_I2C_hard_06.mbas,34 :: 		I2C1_Wr(Raddr)      ' send address via I2C (device address + W)
	MOVLW       79
	MOVWF       FARG_I2C1_Wr_data_+0 
	CALL        _I2C1_Wr+0, 0
;LCD_I2C_hard_06.mbas,35 :: 		Read_I2C=I2C1_Rd(0)
	CLRF        FARG_I2C1_Rd_ack+0 
	CALL        _I2C1_Rd+0, 0
	MOVF        R0, 0 
	MOVWF       Read_I2C_local_result+0 
;LCD_I2C_hard_06.mbas,36 :: 		I2C1_stop
	CALL        _I2C1_Stop+0, 0
;LCD_I2C_hard_06.mbas,37 :: 		end sub
	MOVF        Read_I2C_local_result+0, 0 
	MOVWF       R0 
L_end_Read_I2C:
	RETURN      0
; end of _Read_I2C

_send_CReg:

;LCD_I2C_hard_06.mbas,47 :: 		dim hi_n, lo_n  as byte
;LCD_I2C_hard_06.mbas,48 :: 		hi_n = cmd and 0xF0       lo_n=(cmd and 0x0F) << 4
	MOVLW       240
	ANDWF       FARG_send_CReg_cmd+0, 0 
	MOVWF       R1 
	MOVF        R1, 0 
	MOVWF       send_CReg_hi_n+0 
	MOVLW       15
	ANDWF       FARG_send_CReg_cmd+0, 0 
	MOVWF       send_CReg_lo_n+0 
	RLCF        send_CReg_lo_n+0, 1 
	BCF         send_CReg_lo_n+0, 0 
	RLCF        send_CReg_lo_n+0, 1 
	BCF         send_CReg_lo_n+0, 0 
	RLCF        send_CReg_lo_n+0, 1 
	BCF         send_CReg_lo_n+0, 0 
	RLCF        send_CReg_lo_n+0, 1 
	BCF         send_CReg_lo_n+0, 0 
;LCD_I2C_hard_06.mbas,49 :: 		send_I2C(hi_n or 0x0C)  portd=Read_I2C ' delay_ms(1) ' D=1 E=1 RW=0 RS=0
	MOVLW       12
	IORWF       R1, 0 
	MOVWF       FARG_Send_I2C_dat+0 
	CALL        _Send_I2C+0, 0
	CALL        _Read_I2C+0, 0
	MOVF        R0, 0 
	MOVWF       PORTD+0 
;LCD_I2C_hard_06.mbas,50 :: 		send_I2C(hi_n or 0x80)  portd=Read_I2C ' delay_ms(1) ' D=1 E=0 RW=0 RS=0
	MOVLW       128
	IORWF       send_CReg_hi_n+0, 0 
	MOVWF       FARG_Send_I2C_dat+0 
	CALL        _Send_I2C+0, 0
	CALL        _Read_I2C+0, 0
	MOVF        R0, 0 
	MOVWF       PORTD+0 
;LCD_I2C_hard_06.mbas,51 :: 		send_I2C(lo_n or 0x0C)  portd=Read_I2C ' delay_ms(1) ' D=1 E=1 RW=0 RS=0
	MOVLW       12
	IORWF       send_CReg_lo_n+0, 0 
	MOVWF       FARG_Send_I2C_dat+0 
	CALL        _Send_I2C+0, 0
	CALL        _Read_I2C+0, 0
	MOVF        R0, 0 
	MOVWF       PORTD+0 
;LCD_I2C_hard_06.mbas,52 :: 		send_I2C(lo_n or 0x80)  portd=Read_I2C ' delay_ms(1) ' D=1 E=0 RW=0 RS=0
	MOVLW       128
	IORWF       send_CReg_lo_n+0, 0 
	MOVWF       FARG_Send_I2C_dat+0 
	CALL        _Send_I2C+0, 0
	CALL        _Read_I2C+0, 0
	MOVF        R0, 0 
	MOVWF       PORTD+0 
;LCD_I2C_hard_06.mbas,53 :: 		end sub
L_end_send_CReg:
	RETURN      0
; end of _send_CReg

_send_DReg:

;LCD_I2C_hard_06.mbas,56 :: 		dim hi_n, lo_n  as byte
;LCD_I2C_hard_06.mbas,57 :: 		hi_n = dat and 0xF0       lo_n=(dat and 0x0F) << 4
	MOVLW       240
	ANDWF       FARG_send_DReg_dat+0, 0 
	MOVWF       R1 
	MOVF        R1, 0 
	MOVWF       send_DReg_hi_n+0 
	MOVLW       15
	ANDWF       FARG_send_DReg_dat+0, 0 
	MOVWF       send_DReg_lo_n+0 
	RLCF        send_DReg_lo_n+0, 1 
	BCF         send_DReg_lo_n+0, 0 
	RLCF        send_DReg_lo_n+0, 1 
	BCF         send_DReg_lo_n+0, 0 
	RLCF        send_DReg_lo_n+0, 1 
	BCF         send_DReg_lo_n+0, 0 
	RLCF        send_DReg_lo_n+0, 1 
	BCF         send_DReg_lo_n+0, 0 
;LCD_I2C_hard_06.mbas,58 :: 		send_I2C(hi_n or 0x0D)  portd=Read_I2C ' delay_ms(1) ' D=1 E=1 RW=0 RS=1
	MOVLW       13
	IORWF       R1, 0 
	MOVWF       FARG_Send_I2C_dat+0 
	CALL        _Send_I2C+0, 0
	CALL        _Read_I2C+0, 0
	MOVF        R0, 0 
	MOVWF       PORTD+0 
;LCD_I2C_hard_06.mbas,59 :: 		send_I2C(hi_n or 0x09)  portd=Read_I2C ' delay_ms(1) ' D=1 E=0 RW=0 RS=1
	MOVLW       9
	IORWF       send_DReg_hi_n+0, 0 
	MOVWF       FARG_Send_I2C_dat+0 
	CALL        _Send_I2C+0, 0
	CALL        _Read_I2C+0, 0
	MOVF        R0, 0 
	MOVWF       PORTD+0 
;LCD_I2C_hard_06.mbas,60 :: 		send_I2C(lo_n or 0x0D)  portd=Read_I2C ' delay_ms(1) ' D=1 E=1 RW=0 RS=1
	MOVLW       13
	IORWF       send_DReg_lo_n+0, 0 
	MOVWF       FARG_Send_I2C_dat+0 
	CALL        _Send_I2C+0, 0
	CALL        _Read_I2C+0, 0
	MOVF        R0, 0 
	MOVWF       PORTD+0 
;LCD_I2C_hard_06.mbas,61 :: 		send_I2C(lo_n or 0x09)  portd=Read_I2C ' delay_ms(1) ' D=1 E=0 RW=0 RS=1
	MOVLW       9
	IORWF       send_DReg_lo_n+0, 0 
	MOVWF       FARG_Send_I2C_dat+0 
	CALL        _Send_I2C+0, 0
	CALL        _Read_I2C+0, 0
	MOVF        R0, 0 
	MOVWF       PORTD+0 
;LCD_I2C_hard_06.mbas,62 :: 		end sub
L_end_send_DReg:
	RETURN      0
; end of _send_DReg

_goto_yx:

;LCD_I2C_hard_06.mbas,64 :: 		sub procedure goto_yx(dim y, x as byte) ' y=1,2 lines ...  x=1 .. 16 chars
;LCD_I2C_hard_06.mbas,65 :: 		x = (x-1) mod 16
	DECF        FARG_goto_yx_x+0, 1 
	MOVLW       15
	ANDWF       FARG_goto_yx_x+0, 1 
;LCD_I2C_hard_06.mbas,67 :: 		case 1  send_CReg(0x80+0x00+x)' delay_ms(10)  ' first line
	MOVF        FARG_goto_yx_y+0, 0 
	XORLW       1
	BTFSS       STATUS+0, 2 
	GOTO        L__goto_yx8
	MOVF        FARG_goto_yx_x+0, 0 
	ADDLW       128
	MOVWF       FARG_send_CReg_cmd+0 
	CALL        _send_CReg+0, 0
	GOTO        L__goto_yx5
L__goto_yx8:
;LCD_I2C_hard_06.mbas,68 :: 		case 2  send_CReg(0x80+0x40+x)' delay_ms(10)  ' second line
	MOVF        FARG_goto_yx_y+0, 0 
	XORLW       2
	BTFSS       STATUS+0, 2 
	GOTO        L__goto_yx11
	MOVF        FARG_goto_yx_x+0, 0 
	ADDLW       192
	MOVWF       FARG_send_CReg_cmd+0 
	CALL        _send_CReg+0, 0
	GOTO        L__goto_yx5
L__goto_yx11:
L__goto_yx5:
;LCD_I2C_hard_06.mbas,70 :: 		end sub
L_end_goto_yx:
	RETURN      0
; end of _goto_yx
